'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DesktopComponent = require('../DesktopComponent');

var _DesktopComponent2 = _interopRequireDefault(_DesktopComponent);

var _PanePaneWindows = require('./Pane/Pane.windows');

var _PanePaneWindows2 = _interopRequireDefault(_PanePaneWindows);

var _ItemItemWindows = require('./Item/Item.windows');

var _ItemItemWindows2 = _interopRequireDefault(_ItemItemWindows);

var _ContentContentWindows = require('./Content/Content.windows');

var _ContentContentWindows2 = _interopRequireDefault(_ContentContentWindows);

var styles = {
  display: 'flex',
  flexWrap: 'nowrap',
  position: 'relative',
  flex: '1'
};

var SplitView = (function (_Component) {
  _inherits(SplitView, _Component);

  _createClass(SplitView, null, [{
    key: 'Pane',
    value: _PanePaneWindows2['default'],
    enumerable: true
  }, {
    key: 'Content',
    value: _ContentContentWindows2['default'],
    enumerable: true
  }, {
    key: 'Item',
    value: _ItemItemWindows2['default'],
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      id: _react.PropTypes.string,
      compactLength: _react.PropTypes.number,
      openLength: _react.PropTypes.number,
      placement: _react.PropTypes.string,
      isOpen: _react.PropTypes.bool,
      persistIsOpen: _react.PropTypes.bool,
      persistSelectedItem: _react.PropTypes.bool,
      push: _react.PropTypes.bool,
      onPaneToggle: _react.PropTypes.func
    },
    enumerable: true
  }, {
    key: 'childContextTypes',
    value: {
      id: _react.PropTypes.string,
      compactLength: _react.PropTypes.number,
      openLength: _react.PropTypes.number,
      placement: _react.PropTypes.string,
      isOpen: _react.PropTypes.bool,
      persistIsOpen: _react.PropTypes.bool,
      persistSelectedItem: _react.PropTypes.bool,
      push: _react.PropTypes.bool
    },
    enumerable: true
  }]);

  function SplitView(props, context, updater) {
    _classCallCheck(this, _SplitView);

    var id = props.id;

    var properties = _objectWithoutProperties(props, ['id']);

    _get(Object.getPrototypeOf(_SplitView.prototype), 'constructor', this).call(this, properties, context, updater);
    this.id = id || 'splitview';
  }

  _createClass(SplitView, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        id: this.id,
        compactLength: this.props.compactLength,
        openLength: this.props.openLength,
        placement: this.props.placement,
        isOpen: this.props.isOpen,
        persistIsOpen: this.props.persistIsOpen,
        persistSelectedItem: this.props.persistSelectedItem,
        push: this.props.push
      };
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      for (var prop in this.refs) {
        if (this.refs.hasOwnProperty(prop)) {
          this.refs[prop].setState({ parentRequestedTheme: this.state.requestedTheme });
        }
      }
    }
  }, {
    key: 'selectItem',
    value: function selectItem(item) {
      if (this.refs && this.context.storage && this.props.persistSelectedItem) {
        for (var prop in this.refs) {
          if (this.refs.hasOwnProperty(prop)) {
            if (this.refs[prop].props.storageKey === item.props.storageKey) {
              this.context.storage[this.getItemStorageKey(this.refs[prop].props.storageKey)] = true;
              this.refs[prop].setState({ selected: true });
            } else {
              this.context.storage[this.getItemStorageKey(this.refs[prop].props.storageKey)] = false;
              this.refs[prop].setState({ selected: false });
            }
          }
        }
      }
    }
  }, {
    key: 'getItemStorageKey',
    value: function getItemStorageKey(key) {
      return '.' + this.id + '.$/.' + key;
    }
  }, {
    key: 'getPersistedSelectedItem',
    value: function getPersistedSelectedItem(key) {
      if (typeof this.context.storage[this.getItemStorageKey(key)] !== 'undefined') {
        return this.context.storage[this.getItemStorageKey(key)] === 'true';
      }
      return null;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this = this;

      var _props = this.props;
      var children = _props.children;
      var style = _props.style;

      var props = _objectWithoutProperties(_props, ['children', 'style']);

      var hasSelectedItem = false;
      _react.Children.map(children, function (child) {
        if (child.props.selected) {
          hasSelectedItem = true;
        }
      });

      var content = _react.Children.map(children, function (child, key) {
        var props = { ref: key, storageKey: key };
        if (!hasSelectedItem && key === 0) {
          props.selected = true;
        }
        if (_this.props.persistSelectedItem && _this.context.storage) {
          if (_this.getPersistedSelectedItem(key) !== null) {
            props.selected = _this.getPersistedSelectedItem(key);
          }
        }
        return (0, _react.cloneElement)(child, props);
      });

      return _react2['default'].createElement(
        'div',
        _extends({
          style: _extends({}, styles, style)
        }, props),
        _react2['default'].createElement(
          _PanePaneWindows2['default'],
          { onPaneToggle: this.props.onPaneToggle },
          content
        ),
        content
      );
    }
  }, {
    key: 'currentTitle',
    set: function set(value) {
      this._currentTitle = value;
    },
    get: function get() {
      return this._currentTitle || '';
    }
  }]);

  var _SplitView = SplitView;
  SplitView = (0, _DesktopComponent2['default'])(SplitView) || SplitView;
  return SplitView;
})(_react.Component);

exports['default'] = SplitView;
module.exports = exports['default'];